package com.ekexiu.console.system.dao;

import java.sql.Connection;
import java.sql.SQLException;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.Dynamic;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.IncludeFixSet;
import org.jfw.apt.orm.annotation.dao.method.Or;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.GtEq;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.LtEq;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.util.PageQueryResult;

import com.ekexiu.console.system.po.User;

@DAO
public interface UserDao {

	@Insert
	int insert(Connection con, User user) throws SQLException;

	@Nullable
	@SelectOne
	User queryById(Connection con, String id) throws SQLException;

	@Or
	@Nullable
	@SelectOne
	User queryByLoginKey(Connection con, @Alias({ "mobile", "email" }) String key) throws SQLException;

	@Update
	@Dynamic
	int update(Connection con, User user) throws SQLException;

	@Batch
	@IncludeFixSet("modifyTime")
	@UpdateWith
	@From(User.class)
	int[] resetPassword(Connection con,@Batch  String[] id, @Set String loginPassword) throws SQLException;

	@IncludeFixSet("modifyTime")
	@UpdateWith
	@From(User.class)
	int update(Connection con, String id, @Set String authinfo) throws SQLException;

	@Where("ACTIVED<>'1'")
	@SetSentence("ACTIVED='1'")
	@IncludeFixSet("modifyTime")
	@From(User.class)
	@UpdateWith
	int enable(Connection con, String id) throws SQLException;

	@Where("ACTIVED='1'")
	@SetSentence("ACTIVED='0'")
	@IncludeFixSet("modifyTime")
	@From(User.class)
	@UpdateWith
	int dsiable(Connection con, String id) throws SQLException;

	@PageSelect
	public PageQueryResult<User> pageQuery(Connection con, @Nullable @Like String name, @Nullable Boolean actived, @Nullable String mobile,
			@Nullable String email, @Nullable @GtEq @Alias("createTime") String bt, @Nullable @Alias("createTime") @LtEq String et, int pageNo, int pageSize)
			throws SQLException;

}
